/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-10-26 17:30
 **/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b){ return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b){ return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MOD = 998'244'353;

const ll MAXN = 1e5 + 5;
const ll INF = 1LL << 60;

ll N, M;

vector<int> edges[MAXN];
vector<int> used;

int bfs(int s){
    used.assign(N + 2, -1);
    queue<int> q({s});
    used[s] = 0;

    while(not empty(q)){
        s = q.front();
        q.pop();
        for(int v : edges[s]){
            if(used[v] == -1){
                used[v] = used[s] + 1;
                q.push(v);
            }
        }
    }
    // determine the node farthest away
    auto it = R::max_element(used);
    return it - begin(used);
}

void solve(){
    // Code goes here ...
    cin >> N >> M;

    int u, v;
    R(i, M){
        cin >> u >> v;
        edges[u].push_back(v);
        edges[v].push_back(u);
    }

    int rimpoint = bfs(1);
    F(i, 1, N+1){
        if(used[i] == -1){
            cout << -1 << endl;
            return;
        }
    }

    int orimpoint = bfs(rimpoint);
    int res = used[orimpoint];
    res = log2(res) + 1;

    cout << res << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    // cin >> T;
    while(T--)
        solve();

    /* string rest; */
    /* while(cin.peek() != char_traits<char>::eof()){ */
    /*     solve(); */
    /*     getline(cin, rest); */
    /* } */

    return 0;
}
        
